#include <Wire.h>  // 引入 I2C 库

void setup() {
  Serial.begin(115200);  // 初始化串口
  Serial.println("\nI2C Scanner - ESP12F");

  // 初始化 I2C 并指定 SDA 和 SCL 引脚
  Wire.begin(14, 12); // SDA = GPIO14, SCL = GPIO12

  Serial.println("Scanning for I2C devices...\n");
}

void loop() {
  byte error, address;
  int nDevices = 0;

  for (address = 1; address < 127; address++) {
    Wire.beginTransmission(address);
    error = Wire.endTransmission();

    if (error == 0) {
      Serial.print("I2C device found at address 0x");
      Serial.println(address, HEX);
      nDevices++;
    } else if (error == 4) {
      Serial.print("Unknown error at address 0x");
      Serial.println(address, HEX);
    }
  }

  if (nDevices == 0) {
    Serial.println("No I2C devices found.\n");
  } else {
    Serial.println("Scan complete.\n");
  }

  delay(1000); // 每 5 秒重新扫描一次
}
